#include "MersenneTwister_kernel.cu"
#include "matrix_kernel.cu"
#include "NeuralNetwork.h"
#include <time.h>

//-----------------------
// RBMC constants
//-----------------------
#define BATCH_SIZE 512
#define VIS_SIZE 512
#define HID_SIZE 512

int main(int argc, char* argv[]){
    //struct timeval start, end;
    //long mtime, seconds, useconds;
    
    //gettimeofday(&start, NULL);
    CUT_DEVICE_INIT(argc, argv);
    //Could make this static initialize, but then would have huge executable
    NeuralNetwork<BATCH_SIZE, VIS_SIZE, HID_SIZE>* rbm 
       = new NeuralNetwork<BATCH_SIZE, VIS_SIZE, HID_SIZE>("weight_gen_float.bin", "data.bin");
    
    //rbm->train();

    while (true){
        char action = 'q';
        printf("\nWhat do you wish to do?\n\t'q' - quit\n\t'l' - load image 'digit.pgm' and recognize\n\t't' - train the neural network\nAction: ");
        scanf("%c", &action);
        
        if (action == 'q') break;
        else if (action == 't') { rbm->train(); continue; }
        else if (action != 'l') continue;
        
        unsigned int data[512];
        unsigned int x = 22, y = 22;
        unsigned int * adata = data;
        CUDA_SAFE_CALL( cutLoadPGMi( "digit.pgm", &adata, &x, &y));
        data[0] = 1;
        for (int i=1; i<486; i++) data[i] = !(data[i]>0);
        for (int i=486; i<512; i++) data[i]=0;
        
        //for (int i=0; i<512; i++) printf("%d ", data[i]);
        
        rbm->solve(data);
    }
    /*
    gettimeofday(&end, NULL);

    seconds  = end.tv_sec  - start.tv_sec;
    useconds = end.tv_usec - start.tv_usec;

    mtime = ((seconds) * 1000 + useconds/1000.0) + 0.5;

    printf("Elapsed time: %ld milliseconds\n", mtime);
    */
    return 0;
}
